from abc import ABC


class Metric(ABC):
    def __init__(self, name: str, model: torch.nn.Module = None, **kwargs):
        self.name = name
        self.model = model
        if is_model_needed and model is None:
            raise ValueError(f"{self.name} needs model to perform measurements")

    def is_model_needed(self):
        if "fidelity" in self.name:
            return True
        else:
            return False

    @abstractmethod
    def __call__(self, exp: Explanation, **kwargs) -> float:
        pass
